<?php

CLASS macf extends RasioProject
{
	protected $set;
	protected $enableCk = true;

	public function __construct($config)
	{
		$this->getConfig($config);
		$this->validation();
		$this->set();
	}

	protected function set()
	{
		$this->set->em 			= $this->em;
		$this->set->modul 		= 'Master Account Cash Flow';
		$this->set->dBaseH 		= 'accf';
		$this->set->dBaseD 		= false;
		$this->set->dBasePk 	= array('kdac');
		$this->set->where 		= array("jenis = '1'");
		$this->set->dSort 		= 'asc';
		$this->set->form 		= $this->setForm();
		$this->set->clearForm 	= array("ket_induk");
		$this->set->notNull 	= array("kdac", "nmac", "induk", "grup", "detil");
		$this->set->grid 		= $this->setGrid();
		$this->set->cetak 		= $this->setPrint();
		$this->set->button 		= array("First", "Prev", "Next", "Last", "Browse", "Add", "Del", "Edit", "prinT");
		$this->set->addClear 	= true;
		return $this->set;
	}
	
	protected function setForm()
	{
		$form[] = array('row' => 25, 'col' => 25, "label" => array("name" => "Kode Account", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'kdac', "size" => 10)));
		$form[] = array('row' => 50, 'col' => 25, "label" => array("name" => "Nama Account", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'nmac', "size" => 30)));
		$form[] = array('row' => 75, 'col' => 220, "label" => false, "input" => array("type" => 'text',	'attr' => array("name" => 'ket_induk', "size" => 50, 'readonly' => true)));
		$form[] = array('row' => 75, 'col' => 25, "label" => array("name" => "Induk", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'induk', "size" => 10, 'after' => 'load("Mac", "false", "account")', 'display' => 'account', 'target' => 'ket_induk')));
		$form[] = array('row' => 100, 'col' => 25, "label" => array("name" => "Detil", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'detil', "size" => 4, 'after' => 'select("")', 'select' => 'tf')));
		$form[] = array('row' => 125, 'col' => 25, "label" => array("name" => "Group", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'grup', "size" => 4, 'after' => 'select("")', 'select' => 'grupakun')));
		$form[] = array('row' => 150, 'col' => 25, "label" => array("name" => "Keterangan", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'ket', "size" => 50)));

		$form[] = array('row' => 200, 'col' => 25, "label" => array("name" => "By", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'chusr', 'size' => 15, 'readonly' => true)));
		$form[] = array('row' => 200, 'col' => 500, "label" => array("name" => "Last", "width" => 100), "input" => array("type" => 'text',	'attr' => array("name" => 'chtime', 'size' => 20, 'readonly' => true)));
		return $form;
	}
	
	protected function setGrid()
	{
		$kode = new Kode;
		$res->page 	= 50;
		$res->sortA = $kode->getPk($this->set->dBasePk);
		$res->sortT = 'asc';
		
		$res->attr[]	= array("label" => 'Induk', 'attr' => 'a.induk', "sort" => 'true', "width" => 70, 'align' => 'left', 'focus' => 'true');
		$res->attr[]	= array("label" => 'Kode', 'attr' => 'a.kdac', "sort" => 'true', "width" => 70, 'align' => 'left');
		$res->attr[]	= array("label" => 'Nama', 'attr' => 'a.nmac', "sort" => 'true', "width" => 200, 'align' => 'left');
		$res->attr[]	= array("label" => 'Detail', 'attr' => 'a.detil', "sort" => 'true', "width" => 50, 'align' => 'left');
		$res->attr[]	= array("label" => 'Group', 'attr' => 'a.grup', "sort" => 'true', "width" => 50, 'align' => 'left');
		
		return $res;
	}
	
	protected function setPrint()
	{
		$kode = new Kode;
		$res->sortA = $kode->getPk($this->set->dBasePk);
		$res->sortT = 'asc';
		$res->width = '600px';
		
		$res->attr[]	= array("label" => 'Induk', 'attr' => 'a.induk', "sort" => 'true', "width" => 70, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Kode', 'attr' => 'a.kdac', "sort" => 'true', "width" => 70, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Nama', 'attr' => 'a.nmac', "sort" => 'true', "width" => 200, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Detail', 'attr' => 'a.detil', "sort" => 'true', "width" => 50, 'align' => 'left', 'filter' => true);
		$res->attr[]	= array("label" => 'Group', 'attr' => 'a.grup', "sort" => 'true', "width" => 50, 'align' => 'left', 'filter' => true);
		
		return $res;
	}
	
	public function Index()
	{
		$this->data = $this->set;
		$this->view = "default/index";
	}
	
	public function data()
	{
		$basic = new Basic;
		$this->data = $basic->data($_GET, $this->set);
		$this->view = "default/displayData";
		$this->layout = "view";
	}
	
	public function Find()
	{
		$basic = new Basic;
		$this->data = $basic->find($_GET, $this->set);
		$this->view = "default/displayForm";
		$this->layout = "view";
	}
	
	protected function validasi()
	{
		$basic = new Basic;
		$error[] = $basic->validasiBasic($_POST, $this->set);
		return $basic->getError($error);
	}
	
	public function proses()
	{
		$basic = new Basic;
		$validasi = $this->validasi();
		if($validasi == true){
			$basic->proses($_POST, $this->set, $attrTambah);
		}
		$this->layout = "null";
	}
	
	public function Delete()
	{
		$basic = new Basic;
		$this->data = $basic->delete($_GET, $this->set);
		$this->layout = "null";
	}
	
	public function cetak()
	{
		$basic = new Basic;
		$this->data->data = $basic->printer($_GET, $this->set);
		$this->data->width = $this->set->cetak->width;
		$this->view = "default/cetak";
		$this->layout = "print";
	}
	
	public function load()
	{
		$basic = new Basic;
		$this->data = $basic->load($_GET, $this->set);
		$this->layout = "null";
	}
	
	public function account()
	{
		$data = $this->em->getFind("acc", "nmac", array("kdac = '".$_GET['idRef']."'"));
		
		$res->target = $_GET['target'];
		$res->nama 	= $data->nmac;
		echo json_encode($res);
		$this->layout = "null";
	}
	
	public function popUp()
	{
		$basic = new Basic;
		$this->data = $basic->data($_GET, $this->set);
		$this->view = "default/displayDataPopUp";
		$this->layout = "view";
	}
}